import .connectives
import .leibniz
import .logic
import .relations
axiom nat.nat : Type.
constant nat.O : nat.nat.
constant nat.S : (nat.nat) -> nat.nat.
constant nat.match_nat_type : forall (return : Type) , (return) -> ((nat.nat) -> return) -> (nat.nat) -> return.
axiom nat.axiom_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((connectives.equal) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n)).
theorem nat.eq_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n)) := fun (return_type : Type) , fun (case_O : return_type) , fun (case_S : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@connectives.equal_leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n))) (((((@nat.axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
theorem nat.sym_eq_match_nat_type_S : forall (return_type : Type) , forall (case_O:return_type) , forall (case_S:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((case_S) (n))) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n))) := fun (return_type : Type) , fun (case_O : return_type) , fun (case_S : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@leibniz.sym_leibniz) (return_type)) (((((nat.match_nat_type) (return_type)) (case_O)) (case_S)) (((nat.S) ) (n)))) ((case_S) (n))) (((((@nat.eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
constant nat.filter_nat_type : forall (return : Type) , ((nat.nat) -> return) -> (nat.nat) -> return.
axiom nat.axiom_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((connectives.equal) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) )).
theorem nat.eq_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((leibniz.leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) )) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , ((((@connectives.equal_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) ))) (((@nat.axiom_filter_nat_type_O) (return_type)) (return)).
theorem nat.sym_eq_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((leibniz.leibniz) (return_type)) ((return) ((nat.O) ))) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) )) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , ((((@leibniz.sym_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) ))) (((@nat.eq_filter_nat_type_O) (return_type)) (return)).
axiom nat.axiom_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((connectives.equal) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n))).
theorem nat.eq_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n))) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@connectives.equal_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n)))) ((((@nat.axiom_filter_nat_type_S) (return_type)) (return)) (n)).
theorem nat.sym_eq_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((return) (((nat.S) ) (n)))) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n))) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@leibniz.sym_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n)))) ((((@nat.eq_filter_nat_type_S) (return_type)) (return)) (n)).
axiom nat.nat_ind : forall (Q:(nat.nat) -> Prop) , ((Q) ((nat.O) )) -> (forall (x:nat.nat) , ((Q) (x)) -> (Q) (((nat.S) ) (x))) -> forall (x:nat.nat) , (Q) (x).
noncomputable def nat.pred_ : (nat.nat) -> nat.nat := fun (n : nat.nat) , ((((nat.match_nat_type) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) (n).
constant nat.plus : (nat.nat) -> (nat.nat) -> nat.nat.
constant nat.plus_body : (nat.nat) -> (nat.nat) -> nat.nat.
axiom nat.axiom_plus : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n)).
theorem nat.eq_plus : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n)) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n))) ((@nat.axiom_plus) (n)).
theorem nat.sym_eq_plus : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n))) (((nat.plus) ) (n)) := fun (n : nat.nat) , ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n))) ((@nat.eq_plus) (n)).
axiom nat.axiom_plus_body_O : (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m).
theorem nat.eq_plus_body_O : (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m) := ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m)) (@nat.axiom_plus_body_O).
theorem nat.sym_eq_plus_body_O : (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (fun (m : nat.nat) , m)) (((nat.plus_body) ) ((nat.O) )) := ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m)) (@nat.eq_plus_body_O).
axiom nat.axiom_plus_body_S : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m))).
theorem nat.eq_plus_body_S : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m))) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m)))) ((@nat.axiom_plus_body_S) (n)).
theorem nat.sym_eq_plus_body_S : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m)))) (((nat.plus_body) ) (((nat.S) ) (n))) := fun (n : nat.nat) , ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m)))) ((@nat.eq_plus_body_S) (n)).
theorem nat.pred_Sn : forall (n:nat.nat) , (((logic.eq_) (nat.nat)) (n)) (((nat.pred_) ) (((nat.S) ) (n))) := fun (n : nat.nat) , ((((((@nat.sym_eq_match_nat_type_S) (nat.nat)) ((nat.O) )) (fun (p : nat.nat) , p)) (n)) (fun (y : nat.nat) , (((logic.eq_) (nat.nat)) (n)) (y))) (((@logic.refl_) (nat.nat)) (n)).
theorem nat.injective_S : ((relations.injective) (nat.nat) (nat.nat)) ((nat.S) ) := fun (x : nat.nat) , fun (y : nat.nat) , fun (auto : (((logic.eq_) (nat.nat)) (((nat.S) ) (x))) (((nat.S) ) (y))) , (((((((@logic.rewrite_l) (nat.nat)) (y)) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (__)) (y))) (((@logic.refl_) (nat.nat)) (y))) (x)) (((((((@logic.rewrite_r) (nat.nat)) (((nat.pred_) ) (((nat.S) ) (x)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (y)) (__))) (((((((@logic.rewrite_r) (nat.nat)) (((nat.S) ) (y))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (y)) (((nat.pred_) ) (__)))) ((@nat.pred_Sn) (y))) (((nat.S) ) (x))) (auto))) (x)) ((@nat.pred_Sn) (x)))).
theorem nat.plus_n_Sm : forall (n:nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((((nat.plus) ) (n)) (m)))) ((((nat.plus) ) (n)) (((nat.S) ) (m))) := fun (n : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((((nat.plus) ) (_x_365)) (m)))) ((((nat.plus) ) (_x_365)) (((nat.S) ) (m))))) (fun (m : nat.nat) , (((@nat.sym_eq_plus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((y) (m)))) ((((nat.plus) ) ((nat.O) )) (((nat.S) ) (m))))) ((((@nat.sym_eq_plus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) ((nat.O) )) (m)))) ((y) (((nat.S) ) (m))))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) ((nat.O) )) (m)))) ((y) (((nat.S) ) (m))))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((y) (m)))) ((((nat.plus_body) ) ((nat.O) )) (((nat.S) ) (m))))) (((@nat.sym_eq_plus_body_O) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((y) (m)))) ((((nat.plus_body) ) ((nat.O) )) (((nat.S) ) (m))))) (((@nat.sym_eq_plus_body_O) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (m))) ((y) (((nat.S) ) (m))))) (((@logic.refl_) (nat.nat)) (((nat.S) ) (m)))))))))) (fun (x_366 : nat.nat) , fun (_x_368 : forall (m:nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((((nat.plus) ) (x_366)) (m)))) ((((nat.plus) ) (x_366)) (((nat.S) ) (m)))) , (fun (m : nat.nat) , (((@nat.sym_eq_plus) (((nat.S) ) (x_366))) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((y) (m)))) ((((nat.plus) ) (((nat.S) ) (x_366))) (((nat.S) ) (m))))) ((((@nat.sym_eq_plus) (((nat.S) ) (x_366))) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (((nat.S) ) (x_366))) (m)))) ((y) (((nat.S) ) (m))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (((nat.S) ) (x_366))) (m)))) ((y) (((nat.S) ) (m))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((y) (m)))) ((((nat.plus_body) ) (((nat.S) ) (x_366))) (((nat.S) ) (m))))) ((((@nat.sym_eq_plus_body_S) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((y) (m)))) ((((nat.plus_body) ) (((nat.S) ) (x_366))) (((nat.S) ) (m))))) ((((@nat.sym_eq_plus_body_S) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (((nat.S) ) ((((nat.plus) ) (x_366)) (m))))) ((y) (((nat.S) ) (m))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (m)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (__))) (((nat.S) ) ((((nat.plus) ) (x_366)) (((nat.S) ) (m)))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (((nat.S) ) (m))))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (__)) (((nat.S) ) ((((nat.plus) ) (x_366)) (((nat.S) ) (m)))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (((nat.S) ) (m))))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (((nat.S) ) (m))))) (__))) (((@logic.refl_) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (((nat.S) ) (m)))))) (((nat.S) ) ((((nat.plus) ) (x_366)) (((nat.S) ) (m))))) ((_x_368) (((nat.S) ) (m))))) (((nat.S) ) ((((nat.plus) ) (x_366)) (((nat.S) ) (m))))) ((_x_368) (((nat.S) ) (m))))) (((nat.S) ) ((((nat.plus) ) (x_366)) (m)))) ((_x_368) (m))))))))))) (n).
theorem nat.injective_plus_r : forall (n:nat.nat) , ((relations.injective) (nat.nat) (nat.nat)) (fun (m : nat.nat) , (((nat.plus) ) (n)) (m)) := fun (n : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , ((relations.injective) (nat.nat) (nat.nat)) (fun (m : nat.nat) , (((nat.plus) ) (_x_365)) (m)))) ((((@nat.sym_eq_plus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , ((relations.injective) (nat.nat) (nat.nat)) (fun (m : nat.nat) , (y) (m)))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (y : (nat.nat) -> nat.nat) , ((relations.injective) (nat.nat) (nat.nat)) (fun (m : nat.nat) , (y) (m)))) (((@nat.sym_eq_plus_body_O) (fun (y : (nat.nat) -> nat.nat) , ((relations.injective) (nat.nat) (nat.nat)) (fun (m : nat.nat) , (y) (m)))) (fun (x : nat.nat) , fun (y : nat.nat) , fun (auto : (((logic.eq_) (nat.nat)) (x)) (y)) , (((((((@logic.rewrite_l) (nat.nat)) (x)) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (x)) (__))) (((@logic.refl_) (nat.nat)) (x))) (y)) (auto))))))) (fun (x_366 : nat.nat) , fun (_x_368 : forall (x:nat.nat) , forall (y:nat.nat) , ((((logic.eq_) (nat.nat)) ((((nat.plus) ) (x_366)) (x))) ((((nat.plus) ) (x_366)) (y))) -> (((logic.eq_) (nat.nat)) (x)) (y)) , ((((@nat.sym_eq_plus) (((nat.S) ) (x_366))) (fun (y : (nat.nat) -> nat.nat) , ((relations.injective) (nat.nat) (nat.nat)) (fun (m : nat.nat) , (y) (m)))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (x_366)) (fun (y : (nat.nat) -> nat.nat) , ((relations.injective) (nat.nat) (nat.nat)) (fun (m : nat.nat) , (y) (m)))) ((((@nat.sym_eq_plus_body_S) (x_366)) (fun (y : (nat.nat) -> nat.nat) , ((relations.injective) (nat.nat) (nat.nat)) (fun (m : nat.nat) , (y) (m)))) (fun (x : nat.nat) , fun (y : nat.nat) , fun (auto : (((logic.eq_) (nat.nat)) (((nat.S) ) ((((nat.plus) ) (x_366)) (x)))) (((nat.S) ) ((((nat.plus) ) (x_366)) (y)))) , ((((_x_368) (x)) (y)) ((((@nat.injective_S) ((((nat.plus) ) (x_366)) (x))) ((((nat.plus) ) (x_366)) (y))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (x)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (__)) (((nat.S) ) ((((nat.plus) ) (x_366)) (y))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (y)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (x)))) (__))) (((((((@logic.rewrite_l) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (x)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (x)))) (__))) (((@logic.refl_) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (x))))) ((((nat.plus) ) (x_366)) (((nat.S) ) (y)))) (((((((@logic.rewrite_l) (nat.nat)) (((nat.S) ) ((((nat.plus) ) (x_366)) (y)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (x)))) (__))) (((((((@logic.rewrite_l) (nat.nat)) (((nat.S) ) ((((nat.plus) ) (x_366)) (x)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (__)) (((nat.S) ) ((((nat.plus) ) (x_366)) (y))))) (auto)) ((((nat.plus) ) (x_366)) (((nat.S) ) (x)))) (((@nat.plus_n_Sm) (x_366)) (x)))) ((((nat.plus) ) (x_366)) (((nat.S) ) (y)))) (((@nat.plus_n_Sm) (x_366)) (y))))) (((nat.S) ) ((((nat.plus) ) (x_366)) (y)))) (((@nat.plus_n_Sm) (x_366)) (y)))) (((nat.S) ) ((((nat.plus) ) (x_366)) (x)))) (((@nat.plus_n_Sm) (x_366)) (x))))))))))) (n).
